<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ page import="myjsp.bbs.*, java.util.*"%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>김태용의 JSP 입문 도서 게시판 예제 - 목록보기</title>
<link href="./style.css" rel="stylesheet" type="text/css">
<script type="text/javascript">
function checkvalue() {
	var f = document.search;
	if (f.searchWord.value == "") {
		alert("검색어를 입력하세요.");
		f.searchWord.focus();
		return;
		}
	f.submit();
}

function list() {
	var l = document.list;
	l.action = "list.jsp";
	l.submit();
}

function read(value) {
	var r = document.read;
	r.action = "read.jsp";
	r.num.value = value;
	r.submit();
}
</script>
</head>
<body>
<% // useBean 액션 태그로 myjsp.bbs.BbsManager 빈즈 객체를 생성한다. %>
<jsp:useBean id="db" class="myjsp.bbs.BbsManager"/>
<%
	// 요청 캐릭터 셋 인코딩을 utf-8로 지정한다.
	request.setCharacterEncoding("utf-8");

	int nowPage = 0;		// 현재 페이지 초기화
	int nowBlock = 0;		// 현재 블록 초기화
	int totalRecord = 0;	// 전체 레코드 수 초기화
	int numPerPage = 10;	// 페이지당 레코드 수 초기화
	int totalPage = 0;		// 전체 페이지 수 초기화
	int beginPerPage = 0;	// 페이지 시작 번호 초기화
	int totalBlock = 0;		// 전체 블록 수 초기화
	int pagePerBlock = 10;	// 블록당 페이지 수 초기화

	String searchField = "";	// 검색 필드 초기화
	String searchWord = "";		// 검색어 초기화

	// getDataList() 메서드의 리턴값을 저장할 Vector 생성
	Vector<Object> DataList;

	if (request.getParameter("searchWord") != null) {
		searchWord = request.getParameter("searchWord");
		searchField = request.getParameter("searchField");
	}

	if (request.getParameter("reload") != null) {
		if (request.getParameter("reload").equals("true")) {
			searchWord = "";
			searchField = "";
		}
	}
	
	// searchField, searchWord 매개 변수로 리턴된 전체 게시물을 Vector에 저장한다.
	DataList = db.getDataList(searchField, searchWord);
	// Vector 클래스의 size() 메서드를 사용하여 전체 게시물의 레코드 수를 저장한다.
	totalRecord = DataList.size();
	numPerPage = 10;
	if (request.getParameter("page") != null) {
		// 현재 페이지 저장
		nowPage = Integer.parseInt(request.getParameter("page"));
	}
	// 페이지별 게시물의 시작 번호를 저장한다.
	beginPerPage = nowPage * numPerPage;
	// 전체 페이지 개수 계산 - ceil 메서드 사용으로 소수점은 무조건 올림한다.
	totalPage = (int) Math.ceil((double) totalRecord / numPerPage);

	if (request.getParameter("nowBlock") != null) {
		// 현재 블록을 저장한다.
		nowBlock = Integer.parseInt(request.getParameter("nowBlock"));
	}
	// 전체 블록 개수 계산 - 전체 블록 개수는 전체 페이지 개수를 
	// 블록당 페이지 개수로 나눈 값이다.
	totalBlock = (int) Math.ceil((double) totalPage / pagePerBlock);
%>

<table align=center width=640 border=0 cellspacing=0 cellpadding=3>
	<tr>
		<td align=center colspan=2>
			<h2>김태용의 JSP 입문 도서  게시판 예제 - 목록보기</h2>
		</td>
	</tr>
	<tr>
		<td align=left>
			# 검색어: 
			<% if (searchWord == "") {%>
				없음
			<%}else {%>
				<font color=red><%=searchWord %></font>
			<%} %>
		</td>
		<td align=right>
			전체글수: <%=totalRecord%>개(<font color=red><%=nowPage + 1%>/<%=totalPage%>페이지</font>)
		</td>
	</tr>
	<tr>
		<td align=center colspan=2>
		<table width=100% border=0 cellpadding=3 cellspacing=0>
			<tr bgcolor=#C0C0C0 height=120% class="bold">
				<td align="center" width=50>번 호</td>
				<td align="center" width=350>제 목</td>
				<td align="center" width=50>이 름</td>
				<td align="center" width=100>날 짜</td>
				<td align="center" width=40>조회수</td>
			</tr>
			<%
			if (DataList.isEmpty()) {
			%>
			<tr>
				<td align=center colspan=5>등록된 글이 없습니다.</td>
			</tr>
			<%
			} else {
			// 페이지별 출력할 게시물의 시작 번호부터 페이지당 레코드 수만큼 for문 수행한다.
			for (int i = beginPerPage; i < (beginPerPage + numPerPage); i++) {
				// 출력할 게시물의 시작 번호가 전체 게시물 수와 같으면 for문을 빠져나온다.
				if (i == totalRecord) {break;}
				
				// DB에서 데이터 목록을 Vector 타입으로 가져와서 BbsData 객체에 저장한다.
				BbsData tmpBbs = (BbsData) DataList.elementAt(i);
				// BbsData 객체에 저장되어 있는 데이터를 getXxx() 메서드를 사용하여 가져온다.
				String name = tmpBbs.getName_short();
				String subject = tmpBbs.getSubject_short();
				String email = tmpBbs.getEmail();
				String regdate = tmpBbs.getRegdate_short();
				int depth = tmpBbs.getDepth();
				int num = tmpBbs.getNum();
				int count = tmpBbs.getCount();
			%>
			<tr>
				<td align=center>
					<% // 게시물 번호 출력 %>
					<%=totalRecord - i%>
				</td>
				<td>
					<%
					// 게시물의 depth가 0보다 클 경우, depth보다 작을 때까지
					// 2개의 공백문자를 추가한 다음 데이터를 출력한다.
					if (depth > 0) {
						for (int re = 0; re < depth; re++) {
					%>
						&nbsp;&nbsp;
					<%}%>
						┗ RE:
 					<%}%>
 				<a href="javascript:read('<%=num%>')"><%=subject%></a></td>
				<td align=center><%=name%></td>
				<td align=center><%=regdate%></td>
				<td align=center><%=count%></td>
			</tr>
			<tr>
				<td colspan=5 height=1 bgcolor=#E7E7E7></td>
			</tr>
			<%
				} //inner for
			} //else
				%>
		</table>
		</td>
	</tr>
	<tr>
		<td colspan=2><br><br></td>
	</tr>
	<tr>
		<% /**
			페이징과 블록에 대해 [이전 10개] [1] [2] [3] ... [10] [다음 10개]
			형태를 출력하기 위한 코드이다.
			[이전 10개] 블록은 현재 블록값이 1 이상일 때 보여지고, 
			페이지 링크를 표시하기 위해 게시물을 출력할 때와 같이 10개씩 출력하도록 작성함
			만약, 루프를 수행하다가 총 페이지 링크의 개수와 
			현재 출력할 페이지 번호가 같아지면 루프를 빠져나가도록 작성함
			[다음 10개] 블록이 출력되기 위해서는 현재 블록을 기준으로 
			"현재 블록 + 1"의 값이 총 블록의 개수보다 작아야 한다.
			**/ %>
		<td align=left>
			페이지 이동 
			<%
			if (totalRecord != 0) {
 				if (nowBlock > 0) {
		 	%> <a href="list.jsp?nowBlock=<%=nowBlock - 1%>&page=<%=((nowBlock - 1) * pagePerBlock)%>&searchField=<%=searchField%>&searchWord=<%=searchWord%>">
				이전 <%=pagePerBlock%>개</a> <%
 				}%> ◀ <%
				for (int i = 0; i < pagePerBlock; i++) {
				%>	<a href="list.jsp?nowBlock=<%=nowBlock%>&page=<%=(nowBlock * pagePerBlock) + i%>&searchField=<%=searchField%>&searchWord=<%=searchWord%>">
					<b><font style="font-size: 14pt;"><%=(nowBlock * pagePerBlock) + i + 1%></font></b></a>
				<%
					if ((nowBlock * pagePerBlock) + i + 1 == totalPage) {break;}
				}%> ▶ <%
				if (totalBlock > nowBlock + 1) {
				%>	<a href="list.jsp?nowBlock=<%=nowBlock + 1%>&page=<%=((nowBlock + 1) * pagePerBlock)%>&searchField=<%=searchField%>&searchWord=<%=searchWord%>">
					다음 <%=pagePerBlock%>개</a>
				<%}
			}%>
		</td>
		<td align=right>
			<a href="write.jsp">[글쓰기]</a>
			<a href="javascript:list()">[처음으로]</a>
		</td>
	</tr>
</table>
<% // 검색폼 구성 %>
<form name="search" method="post" action="list.jsp">
<table width=500 align=center border=0 cellpadding=4 cellspacing=0>
	<tr>
		<td align=center valign=bottom>
			<select name="searchField" size=1>
			<option value="name">이 름</option>
			<option value="subject">제 목</option>
			<option value="content" selected>내 용</option>
			</select>
			<input type="text" size=20 name="searchWord" value="">
			<input type="button" value="검색" onClick="checkvalue()">
			<input type="hidden" name="page" value="0">
		</td>
	</tr>
</table>
</form>
<% // 검색 결과 목록 페이지로 보낼 파라미터들의 값 - hidden 처리 %>
<form name=read method=post>
	<input type="hidden" name="num" value="">
	<input type="hidden" name="page" value="<%=nowPage%>">
	<input type="hidden" name="searchField" value="<%=searchField%>">
	<input type="hidden" name="searchWord" value="<%=searchWord%>">
</form>
<form name=list method=post>
	<input type="hidden" name="reload" value="true">
	<input type="hidden" name="page" value="0">
	<input type="hidden" name="nowBlock" value="0">
</form>
</body>
</html>