<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ page import="java.io.*, java.util.*" %>
<%@ page import="org.apache.commons.fileupload.*" %>
<%@ page import="org.apache.commons.fileupload.servlet.*" %>
<%@ page import="org.apache.commons.fileupload.disk.*" %>
<%@ page import="org.apache.commons.fileupload.FileUploadBase.*" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>파일 업로드 처리</title>
</head>
<body>
<h2>파일 업로드 처리</h2>
<hr>
<%
// 1.2 버젼에서는 multipart/form-data 요청인지 확인하기 위해 
// DiskFileUpload가 아니라 ServletFileUpload를 사용한다.
String temp = "c:\\temp"; // 저장소 지정
boolean isMultipart = ServletFileUpload.isMultipartContent(request);
try {
if (isMultipart) {
	// DiskFileItemFactory 생성
	DiskFileItemFactory factory = new DiskFileItemFactory();
	// 1024 Byte * 1024 Byte = 1MByte 까지는 메모리 사용
	factory.setSizeThreshold(1024 * 1024);
	// ServletFileUpload 핸들러 생성
	ServletFileUpload upload = new ServletFileUpload(factory);
	// 10MByte 까지 업로드 가능
	upload.setSizeMax(1024 * 1024 * 10);
	// 한글 처리를 위해 upload 인스턴스의 헤더인코딩을 utf-8로 설정한다.
	upload.setHeaderEncoding("utf-8");
	List<?> items = upload.parseRequest(request);
	
	// 업로드 아이템 처리하기
	Iterator<?> iter = items.iterator();
	while (iter.hasNext()) {
		FileItem item = (FileItem)iter.next();
	if (item.isFormField()) { // 파일이 아닐 경우
		String name = item.getFieldName();
		String value = item.getString("utf-8");
 		out.println(name + " : " + value + "<br>");
	} else { // 파일일 경우
		String fieldName = item.getFieldName(); // 필드명 얻기
		String fileName = item.getName(); // 파일명 얻기
		// 경로를 제외하고 파일명만 얻기
		int idx = fileName.lastIndexOf("\\"); // 윈도우의 경우, c:\ 까지 얻기
		if (idx == -1) {
			idx = fileName.lastIndexOf("/"); // 리눅스의 경우
		}//if
		fileName = fileName.substring(idx + 1);
		String contentType = item.getContentType();
		boolean isInMemory = item.isInMemory();
		long sizeInBytes = item.getSize();
		
		// 업로드 파일 처리하기
		if (sizeInBytes > 0) {
		out.println( fieldName + " : " + temp + "\\" + fileName + " : " + sizeInBytes + " Bytes <br>");
		out.println("컨텐츠 타입 : " + contentType + "<br>");
		out.println("메모리 사용 : " + isInMemory + "<br>");
		try {
			File uploadedFile = new File(temp + "/" + fileName);
			item.write(uploadedFile);
		} catch (IOException e) {
			e.printStackTrace();
		}
		} else {
			InputStream uploadedStream = item.getInputStream();
			uploadedStream.close();
			}
		}// if
	} // while
}
} catch (SizeLimitExceededException e) {
	out.println("업로드 파일 크기가 10메가를 초과하였습니다.<br>");
	out.println(e.getMessage());
} catch (Exception e) {
	out.println("예상하지 못한 오류가 발생하였습니다.<br>");
	out.println(e.getMessage());
}
%>
</body>
</html>