<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ page import="java.io.*, java.util.*" %>
<%@ page import="org.apache.commons.fileupload.*" %>
<%@ page import="org.apache.commons.fileupload.servlet.*" %>
<%@ page import="org.apache.commons.fileupload.disk.*" %>
<%@ page import="myjsp.*" %>
<%@ page import="java.awt.image.*" %>
<%@ page import="javax.imageio.*"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>업로드 이미지 크기 변경 처리</title>
</head>
<body>
<%
// 1.2 버젼에서는 multipart/form-data 요청인지 확인하기 위해 
// DiskFileUpload가 아니라 ServletFileUpload를 사용한다.
String temp = "D:\\java\\workspace\\home\\WebContent\\fileupload\\images"; // 저장소 지정
boolean isMultipart = ServletFileUpload.isMultipartContent(request);
if (isMultipart) {
	// DiskFileItemFactory 생성
	DiskFileItemFactory factory = new DiskFileItemFactory();
	// 1024 Byte * 1024 Byte = 1MByte 까지는 메모리 사용
	factory.setSizeThreshold(1024 * 1024);
	// ServletFileUpload 핸들러 생성
	ServletFileUpload upload = new ServletFileUpload(factory);
	// 10MByte 까지 업로드 가능
	upload.setSizeMax(1024 * 1024 * 10);
	// 한글 처리를 위해 upload 인스턴스의 헤더인코딩을 utf-8로 설정한다.
	upload.setHeaderEncoding("utf-8");
	List<?> items = upload.parseRequest(request);
	
	// 업로드 아이템 처리하기
	Iterator<?> iter = items.iterator();
	while (iter.hasNext()) {
	FileItem item = (FileItem)iter.next();
	if (item.isFormField()) { // 파일이 아닐 경우
		String name = item.getFieldName();
		String value = item.getString("utf-8");
		out.println(name + " : " + value + "<br>");
	} else { // 파일일 경우
		String fieldName = item.getFieldName(); // 필드명 얻기
		String fileName = item.getName(); // 파일명 얻기
		// 경로를 제외하고 파일명만 얻기
		int idx = fileName.lastIndexOf("\\"); // 윈도우의 경우, c:\ 까지 얻기
		if (idx == -1) {
		idx = fileName.lastIndexOf("/"); // 리눅스의 경우
		}
		fileName = fileName.substring(idx + 1);
		String contentType = item.getContentType();
		boolean isInMemory = item.isInMemory();
		long sizeInBytes = item.getSize();
	
		// 업로드 파일 처리하기
		if (sizeInBytes > 0) {
			out.println( fieldName + " : " + temp + "\\" + fileName + " : " + sizeInBytes + " Bytes <br>");
			out.println("컨텐츠 타입 : " + contentType + "<br>");
			out.println("메모리 사용 : " + isInMemory + "<br><hr>");
			try {
				File uploadedFile = new File(temp + "/" + fileName);
				item.write(uploadedFile);
				item.delete();
				// 업로드 파일 크기 변경, 출력 코드
				String[] fileName2 = fileName.split("[.]", 2);
				File destFile = new File(temp + "/" + fileName2[0] + "_thumb.jpg");
				ImgResize.resize(uploadedFile, destFile, 300, ImgResize.RATIO);
				BufferedImage uf = ImageIO.read(uploadedFile);
				BufferedImage df = ImageIO.read(destFile);
%>

<%-- HTML 코드 --%>
원본 이미지 파일 : <%=uploadedFile.getAbsolutePath() %><br>
원본 이미지 파일 크기 : <%=sizeInBytes %> Bytes<br>
원본 이미지 폭/높이 : <%=uf.getWidth() %> x <%=uf.getHeight()%><br>
<img src="<%=temp %>\<%=fileName %>" border="0"><br><hr>
변경된 이미지 파일 : <%=destFile.getAbsolutePath() %><br>
변경된 이미지 파일 크기 : <%=destFile.length() %> Bytes<br>
변경된 이미지 폭/높이 : <%=df.getWidth() %> x <%=df.getHeight() %><br>
<img src="<%=temp %>\<%=fileName2[0] %>_thumb.jpg" border="0">

<%
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			out.println("죄송합니다!<br>업로드 파일을 먼저 선택해 주세요.");
			InputStream uploadedStream = item.getInputStream();
			uploadedStream.close();
		}
	} // if
	} // while
}
%>
</body>
</html>