<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/sql" prefix="sql" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>sql 태그 라이브러리 테스트</title>
</head>
<body>
<h1>member2 테이블 생성과 출력</h1>
<hr>
<%
	String myDate = "2010-01-02";
	java.text.SimpleDateFormat sd = new java.text.SimpleDateFormat("yyyy-MM-dd");
	java.sql.Date sDate = new java.sql.Date(sd.parse(myDate).getTime());
%>
<c:set var="sDate" value="<%=sDate %>" />

<%-- 데이터베이스 접속 --%>
<sql:setDataSource var="testDB" url="jdbc:mysql://localhost:3306/test" 
driver="com.mysql.jdbc.Driver" user="root" password="asdfgh" />

<%-- DataSource와 JNDI를 사용한 데이터베이스 접속
<sql:setDataSource var="testDB" dataSource="jdbc/mysql/test" />
--%>

<sql:transaction dataSource="${testDB}">
	<sql:query var="member2">
		select count(*) from information_schema.tables where table_name = 'member2';
	</sql:query>
	member2 테이블 개수 : ${member2.rowsByIndex[0][0] }
	
	<c:if test="${member2.rowsByIndex[0][0] < 1 }">
		<sql:update var="createTable">
			create table member2 (
			no int(11) not null auto_increment,
			id varchar(20) not null,
			name varchar(20) not null,
			regdate datetime default null,
			primary key (no)
			);
		</sql:update>
		<sql:update var="insert1">
			insert into member2(id, name, regdate) values('dae', '대조영','2010-01-01');
		</sql:update>
		<sql:update var="insert2">
			insert into member2(id, name, regdate) values('wang', '왕건','2010-01-02');
		</sql:update>
		<sql:update var="insert3">
			insert into member2(id, name, regdate) values('lee', '이성계','2010-01-03');
		</sql:update>
	</c:if>

	<sql:query var="count">
		select count(*) from member2;
	</sql:query>
	
	<sql:query var="query1">
		select * from member2;
	</sql:query>
	
	<sql:query var="query2">
		select * from member2 where regdate = ?;
		<sql:param value="2010-01-01" />
	</sql:query>
	
	<sql:query var="query3">
		select * from member2 where regdate >= ?;
		<sql:dateParam value="${sDate }" />
	</sql:query>
	
	<sql:query var="kim">
		select id from member2 where id = ?;
		<sql:param value="kim" />
	</sql:query>
	
	<sql:query var="ai">
		<%-- 정보 테이블에서 다음 데이터로 사용할 auto_increment 값 가져오기 --%>
		select auto_increment from information_schema.tables where table_name='member2';
	</sql:query>
	
	<sql:update var="update">
		update member2 set name=? where id=?;
		<sql:param>자바서버페이지</sql:param> <%-- 첫 번째 ?에 파라미터의 값 적용 --%>
		<sql:param>jsp</sql:param> <%-- 두 번째 ?에 파라미터의 값 적용 --%>
	</sql:update>
</sql:transaction>

<li>[member2 테이블 데이터]
<table border="1" cellspacing="0" cellpadding="5">
	<tr>

<%-- 칼럼의 정보를 출력한다. --%>
<c:forEach var="columnName" items="${query1.columnNames}">
	<th><c:out value="${columnName}" /></th>
</c:forEach>

<%-- 데이터를 한 줄씩 출력한다. --%>
<c:forEach var="row" items="${query1.rowsByIndex}">
	<tr>
	<%-- 칼럼의 길이만큼 반복한다. --%>
	<c:forEach var="column" items="${row}" varStatus="i">
		<td><c:out value="${column}"/></td>
	</c:forEach>
	</tr>
</c:forEach>
</table>
<hr>
<li>[2010-01-01에 등록한 멤버]
<table border="1" cellspacing="0" cellpadding="5">
	<tr>

<%-- 칼럼의 정보를 출력한다. --%>
<c:forEach var="columnName" items="${query2.columnNames}">
	<th><c:out value="${columnName}" /></th>
</c:forEach>

<%-- 데이터를 한 줄씩 출력한다. --%>
<c:forEach var="row" items="${query2.rowsByIndex}">
	<tr>
	<%-- 칼럼의 길이만큼 반복한다. --%>
	<c:forEach var="column" items="${row}" varStatus="i">
		<td><c:out value="${column}"/></td>
	</c:forEach>
	</tr>
</c:forEach>
</table>
<hr>
<li>[${sDate } 이후에 등록한 멤버]<br>
<c:forEach var="q3" items="${query3.rows}">
	${q3.no }, ${q3.id }, ${q3.name}, ${q3.regdate }<br>
</c:forEach>
<hr>

<sql:update var="alter" dataSource="${testDB}">
	alter table member2 auto_increment = 0;
</sql:update>

\${kim.rowsByIndex[0][0] } = ${kim.rowsByIndex[0][0] }<br>
\${kim.rows[0].id } = ${kim.rows[0].id }<br>
<c:if test="${kim.rows[0].id == null}">
	<sql:update var="insert" dataSource="${testDB}">
		insert into member2(id, name, regdate) values('kim', '김태용', '2010-01-04');
	</sql:update>
</c:if>
전체 레코드 개수 : ${count.rowsByIndex[0][0] }<br>
auto_increment(다음 번 insert시 no 필드에 자동으로 부여할) 값 : ${ai.rowsByIndex[0][0] }<br>
</body>
</html>