package myjsp;

import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class Bank1Bean {
	// 멤버 변수 선언
	private int no = 0;
	private String name = null;
	private int money = 0;
	
	// 데이터베이스 관련 인스턴스
	Connection conn = null;
	Statement stmt = null;
	PreparedStatement pstmt = null;

	// DataSource, DBCP를 이용한 connection 메서드
	public void connect() {
		try {
			Context initContext = new InitialContext();
			Context envContext = (Context)initContext.lookup("java:/comp/env");
			DataSource ds = (DataSource)envContext.lookup("jdbc/mysql/test");
			conn = ds.getConnection(); // 커넥션 얻기
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	// connection 반환 메서드
	public void disconnect() {
		try {
			if (conn != null) {
				conn.close();
			}
		} catch (SQLException e) {
			System.out.println(e);
		}
		System.out.println("Bank1 데이터베이스 접속 종료");
	}

	// 테이블에서 데이터 가져오는 메서드
	public void getData() {
		connect();
		try {
			stmt = conn.createStatement();
			String sql = "select * from bank1";
			ResultSet rs = stmt.executeQuery(sql);
			rs.next();
			no = rs.getInt("no");
			name = rs.getString("name");
			money = rs.getInt("money");
		} catch (Exception e) {
			System.out.println(no + " " + name + " " + money);
			e.printStackTrace();
		} finally {
			disconnect();
		}
	}

	// 이체 수행 메서드
	public boolean transfer(int tmoney) {
		connect();
		try {
			conn.setAutoCommit(false);
			String sql1 = "update bank1 set money = money - ? where no = 101";
			pstmt = conn.prepareStatement(sql1);
			pstmt.setInt(1, tmoney);
			pstmt.executeUpdate();
			
			String sql2 = "update bank2 set money = money + ? where no = 201";
			pstmt = conn.prepareStatement(sql2);
			pstmt.setInt(1, tmoney);
			pstmt.executeUpdate();
			
			stmt = conn.createStatement();
			String sql3 = "select money from bank2 where no = 201";
			ResultSet rs = stmt.executeQuery(sql3);
			
			rs.next();
			
			if (rs.getInt(1) > 150) {
				conn.rollback();
				return false;
			} else {
				conn.commit();
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}
		return true;
	}

	// getXxx 메서드
	public int getNo() {
		return no;
	}

	public String getName() {
		return name;
	}

	public int getMoney() {
		return money;
	}
}