package myjsp;

import java.io.*;
import javax.imageio.*;
import javax.imageio.stream.*;
import java.awt.image.*;
import java.awt.*;

public class ImgResize {
	public static final int SAME =  -1;
	public static final int RATIO =  0;
	
	// 원본 이미지를 파일로 전달 받은 경우 호출할 resize() 메서드
	public static void resize(File src, File dest , int width, int height) 
			throws IOException {
		ImageInputStream srcFile = null;
		try {
			srcFile = new FileImageInputStream(src);
			// ImageInputStream을 소스로 전달 받은 경우 resize() 메서드 호출
			ImgResize.resize(srcFile, dest, width, height);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void resize(ImageInputStream src, File dest, int width, int height ) 
			throws NullPointerException, IOException {
		BufferedImage srcImg = ImageIO.read(src);
		// 원본 이미지 파일의 폭과 높이를 구하고 변수로 저장해 둔다.
		int srcWidth = srcImg.getWidth();
		int srcHeight = srcImg.getHeight();
		
		int destWidth = -1;
		int destHeight = -1;
		
		if (width == SAME) {
			destWidth = srcWidth;
		} else if (width > 0) {
			destWidth = width;
		}
		
		if (height == SAME) {
			destHeight = srcHeight;
		} else if (height > 0) {
			destHeight = height;
		}
		
		if (width == RATIO && height == RATIO) {
			destWidth = srcWidth;
			destHeight = srcHeight;
		} else if (width == RATIO) {
			double ratio = ((double)destHeight) / ((double)srcHeight);
			destWidth = (int)((double)srcWidth * ratio);
		} else if (height == RATIO) {
			double ratio = ((double)destWidth) / ((double)srcWidth);
			destHeight = (int)((double)srcHeight * ratio);
		}
		
		BufferedImage destImg = new BufferedImage(destWidth, 
			destHeight, BufferedImage.TYPE_3BYTE_BGR);
		Graphics2D g =  destImg.createGraphics();
		g.drawImage(srcImg, 0, 0, destWidth, destHeight, null);
		ImageIO.write(destImg, "jpg", dest);
	}
}