package myjsp;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.awt.*;
import java.text.*;

import org.jfree.chart.*;
import org.jfree.chart.axis.*;
import org.jfree.chart.entity.*;
import org.jfree.chart.labels.*;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.category.*;
import org.jfree.data.category.*;
import org.jfree.ui.TextAnchor;

public class ServletBarChart3D extends HttpServlet {
	static final long serialVersionUID = 1L;
	public ServletBarChart3D() {
		super();
	}	
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) 
			throws ServletException, IOException {
		doPost(request, response);
	}
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) 
			throws ServletException, IOException {
		response.setContentType("text/html; charset=utf-8");
		PrintWriter out = response.getWriter();
		try {
			DefaultCategoryDataset dataset1 = new DefaultCategoryDataset();

			String[][] arrData1 = {
				{"10.5", "2008 년", "1월"},
				{"16.0", "2008 년", "2월"},
				{"15.0", "2008 년", "3월"},
				{"14.0", "2008 년", "4월"},
				{"21.0", "2008 년", "5월"},
				{"25.0", "2008 년", "6월"},
				{"12.0", "2009 년", "1월"},
				{"19.0", "2009 년", "2월"},
				{"18.0", "2009 년", "3월"},
				{"17.0", "2009 년", "4월"},
				{"30.0", "2009 년", "5월"},
				{"35.0", "2009 년", "6월"}
			};
			
			for (int i = 0; i < arrData1.length; i ++) {
			dataset1.addValue(
				Double.parseDouble(arrData1[i][0]), arrData1[i][1], arrData1[i][2]);
			}
			
			JFreeChart chart1 = ChartFactory.createBarChart3D(
				"월별 매출액", "월", "매출액(단위 : 억)", dataset1, PlotOrientation.VERTICAL, true, true, false);

			chart1.setBackgroundPaint(Color.white);
			// 차트 타이틀 지정
			//chart1.setTitle("월별 매출액");
			// 출력 텍스트의 안티 알리아스 지정
			//chart1.setTextAntiAlias(false);
			// 백그라운드 색 지정
			chart1.setBackgroundPaint(Color.white);
			
			CategoryPlot plot = (CategoryPlot)chart1.getPlot();
			plot.setNoDataMessage("No data to display");
			//plot.setForegroundAlpha(0.5f);
			//plot.getDomainAxis().setVisible(false);
			//plot.getRangeAxis().setVisible(false);
			NumberAxis nx = (NumberAxis)plot.getRangeAxis();
			nx.setUpperMargin(0.15);
			
			CategoryItemRenderer ci = plot.getRenderer();
			ci.setBaseItemLabelsVisible(true);
			StandardCategoryItemLabelGenerator stdItemLabel = new StandardCategoryItemLabelGenerator("{2}억({1})", NumberFormat.getInstance());
			ci.setBaseItemLabelGenerator(stdItemLabel);
			ci.setBaseItemLabelFont(new Font("굴림", Font.BOLD, 12));
			ci.setBasePositiveItemLabelPosition(new ItemLabelPosition( 
			ItemLabelAnchor.OUTSIDE1, TextAnchor.CENTER, TextAnchor.CENTER, -Math.PI/2));
			ci.setBaseNegativeItemLabelPosition(new ItemLabelPosition( 
			ItemLabelAnchor.CENTER, TextAnchor.CENTER, TextAnchor.CENTER, -Math.PI/2));
			
			ChartRenderingInfo info1 = 
				new ChartRenderingInfo(new StandardEntityCollection());
			String fileName1 = 
	"D:\\java\\workspace\\home\\WebContent\\fileupload\\images\\BarChart3D.jpg";
			ChartUtilities.saveChartAsJPEG(
				new File(fileName1), chart1, 600, 400, info1);

			// HTML 코드 생성
			out.println("<html>");
			out.println("<head><title>JFreeChart BarChard3D 예제</title></head>");
			out.println("<body><h2>JFreeChart BarChard3D 예제</h2>");
			out.println("<hr>");
			out.println("파일 위치 : " + fileName1 + "<br>");
			out.println("<img src=" + fileName1 + " />");
			out.println("</body></html>");
		} catch (Exception e) {
			out.println(e.getMessage()); 
		} finally {
			out.close();
		}
	}
}