package myjsp;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.jfree.chart.*;
import org.jfree.data.general.*;
import org.jfree.data.category.*;
import org.jfree.chart.plot.*;
import java.awt.*;

public class ServletJFreeChart extends HttpServlet {
	static final long serialVersionUID = 1L;
	public ServletJFreeChart() {
		super();
	}
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
		doPost(request, response);
	}
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
		response.setContentType("text/html; charset=utf-8");
		PrintWriter out = response.getWriter();
		String file1 = "D:\\java\\workspace\\home\\WebContent\\fileupload\\images\\chart3.jpg";
		String file2 = "D:\\java\\workspace\\home\\WebContent\\fileupload\\images\\chart4.jpg";		
		FileOutputStream fos1 = null;
		FileOutputStream fos2 = null;

		try {
			DefaultCategoryDataset dataset1 = new DefaultCategoryDataset();

			String[][] arrData1 = {
				{"10.5", "2008 년", "1월"},
				{"16.0", "2008 년", "2월"},
				{"15.0", "2008 년", "3월"},
				{"14.0", "2008 년", "4월"},
				{"21.0", "2008 년", "5월"},
				{"25.0", "2008 년", "6월"},
				{"12.0", "2009 년", "1월"},
				{"19.0", "2009 년", "2월"},
				{"18.0", "2009 년", "3월"},
				{"17.0", "2009 년", "4월"},
				{"30.0", "2009 년", "5월"},
				{"35.0", "2009 년", "6월"}
			};
			
			for (int i = 0; i < arrData1.length; i ++) {
				dataset1.addValue(Double.parseDouble(arrData1[i][0]), arrData1[i][1], arrData1[i][2]);
			}
			
			JFreeChart chart1 = ChartFactory.createBarChart(
				"월별 매출액", "월", "매출액(단위 : 억)", dataset1, PlotOrientation.VERTICAL, true, true, false);

			chart1.setBackgroundPaint(Color.white);
			//chart1.setTitle("월별 매출액");

			fos1 = new FileOutputStream(file1);
			ChartUtilities.writeChartAsJPEG(fos1, chart1, 500, 200);

			DefaultPieDataset dataset2 = new DefaultPieDataset();

			String[][] arrData2 = {
				{"1월", "20"},
				{"2월", "8"},
				{"3월", "9"},
				{"4월", "9"},
				{"5월", "35"},
				{"6월", "15"},
				{"7월", "10"},
				{"8월", "9"},
				{"9월", "8"},
				{"10월", "7"},
				{"11월", "5"},
				{"12월", "30"}
			};

			for (int i = 0; i < arrData2.length; i ++) {
				dataset2.setValue(arrData2[i][0], Integer.parseInt(arrData2[i][1]));
			}
			
			JFreeChart chart2 = ChartFactory.createPieChart(
				"월별 매출 통계", dataset2, true, true, false);

			chart2.setBackgroundPaint(Color.white);
			//chart2.setTitle("월별 매출 통계");

			fos2 = new FileOutputStream(file2);
			ChartUtilities.writeChartAsJPEG(fos2, chart2, 500, 200);
			// HTML 코드 생성
			out.println("<html>");
			out.println("<head><title>서블릿 JFreeChart 예제</title></head>");
			out.println("<body><h2>서블릿 JFreeChart 예제</h2>");
			out.println("<hr>");
			out.println("파일 위치 : " + file1 + "<br>");
			out.println("<img src=" + file1 + " />");
			out.println("<hr>");
			out.println("파일 위치 : " + file2 + "<br>");
			out.println("<img src=" + file2 + " />");
			out.println("</body></html>");
		} catch (Exception e) {
			out.println(e.getMessage()); 
		} finally {
			try {
				fos1.close();
				fos2.close();
				out.close();
			} catch (Exception e) { e.getMessage(); }
		}
	}
}