package myjsp;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.awt.*;

import org.jfree.chart.*;
import org.jfree.chart.entity.*;
import org.jfree.chart.labels.*;
import org.jfree.chart.plot.*;
import org.jfree.data.general.*;

public class ServletPieChart3D extends HttpServlet {
	static final long serialVersionUID = 1L;
	public ServletPieChart3D() {
		super();
	}	
	
	protected void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
		doPost(request, response);
	}
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {
		response.setContentType("text/html; charset=utf-8");
		PrintWriter out = response.getWriter();
		try {
			DefaultPieDataset dataset2 = new DefaultPieDataset();
	
			String[][] arrData2 = {
				{"1월", "20"},
				{"2월", "8"},
				{"3월", "9"},
				{"4월", "9"},
				{"5월", "35"},
				{"6월", "15"},
				{"7월", "10"},
				{"8월", "9"},
				{"9월", "8"},
				{"10월", "7"},
				{"11월", "5"},
				{"12월", "30"}
			};
	
			for (int i = 0; i < arrData2.length; i ++) {
				dataset2.setValue(arrData2[i][0], 
				Integer.parseInt(arrData2[i][1]));
			}
			
			JFreeChart chart2 = ChartFactory.createPieChart3D(
				"월별 매출 통계", dataset2, true, true, false);
			
			chart2.setBackgroundPaint(Color.white);
			chart2.setTextAntiAlias(false);
			//chart2.setTitle("월별 매출 통계");

			PiePlot3D plot = (PiePlot3D)chart2.getPlot();
			plot.setLabelFont(new Font("굴림", Font.PLAIN, 12));
			plot.setNoDataMessage("No data to display");
			plot.setCircular(true);
			plot.setStartAngle(150);
			plot.setForegroundAlpha(0.5f);
			plot.setMaximumLabelWidth(0.20); // 2%
			plot.setInteriorGap(0.03); // 3%
			plot.setLabelLinkStyle(PieLabelLinkStyle.STANDARD);
			plot.setLabelGenerator(new StandardPieSectionLabelGenerator("{0} = {1}억 ({2})"));
			
			ChartRenderingInfo info2 = 
				new ChartRenderingInfo(new StandardEntityCollection());
			String fileName2 = "D:\\java\\workspace\\home\\WebContent\\fileupload\\images\\PieChart3D.jpg";
			ChartUtilities.saveChartAsJPEG(
				new File(fileName2), chart2, 600, 400, info2);

			// HTML 코드 생성
			out.println("<html>");
			out.println("<head><title>JFreeChart PieChard3D 예제</title></head>");
			out.println("<body><h2>JFreeChart PieChard3D 예제</h2>");
			out.println("<hr>");
			out.println("파일 위치 : " + fileName2 + "<br>");
			out.println("<img src=" + fileName2 + " />");
			out.println("</body></html>");
		} catch (Exception e) {
			out.println(e.getMessage()); 
		} finally {
			out.close();
		}
	}
}