package myjsp.mvc;

import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class TestController extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    public TestController() {
        super();
    }

    // 1단계: doGet(), doPost() 메서드에서 사용할 하나의 processRequest() 메서드를 호출한다.
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);		
	}

	// processRequest() 메서드를 작성한다.
	private void processRequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// 2단계: 요청 받은 파라미터의 값을 파악한다.
		String msg = request.getParameter("msg");
		
		// 3단계: 앞서 요청받은 msg 파라미터의 값을 검사하여 각각의 경우에 대한  resultObject값을 할당한다.
		Object resultObject = null;
		if(msg == null) {
		resultObject = "msg 파라미터의 값을 입력해 주세요.<br> 예) TestController?msg=hello 또는 TestController?msg=date";
		}else if(msg.equals("hello")) {
			resultObject = "안녕하세요. 반갑습니다.";
		}else if(msg.equals("date")) {
			resultObject = "오늘 날짜와 시간: " + new java.util.Date();
		}else {
			resultObject = "msg 파라미터의 값을 입력해 주세요.<br> 예) TestController?msg=hello 또는  TestController?msg=date";
		}
		
		// 4단계: 앞서 할당 받은 resultObject값을 result 속성에 할당한다.
		request.setAttribute("result", resultObject);
		
		// 5단계: forward() 메서드를 사용하여 적당한 페이지로 포워딩한다.
		RequestDispatcher dispatcher = request.getRequestDispatcher("/mvc/view.jsp");
		dispatcher.forward(request, response);
	}
}