package myjsp.tag;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class ItemNoErrorTag extends BodyTagSupport implements TryCatchFinally {
	private static final long serialVersionUID = 1L;
	public int doStartTag() throws JspException {
		Tag parent = getParent(); // 부모 클래스를 구한다.
		if (parent == null || !(parent instanceof NumberTag)) {
			// 부모 태그가 있는지 검사한다. 
			throw new JspException("parent != NumberTag");
		}
		return EVAL_BODY_BUFFERED;
	}
	public int doEndTag() throws JspException {
		NumberTag numTag = (NumberTag)getParent();
		BodyContent content = getBodyContent();
		try {
			content.getEnclosingWriter().print(numTag.getCurrNumber());
			content.getEnclosingWriter().println(content.getString());
		} catch (IOException e) {
			throw new JspException(e);
		}
		numTag.increaseCurrNumber();
		return EVAL_PAGE;
	}
	public void doCatch(Throwable t) throws Throwable {
		JspWriter out = pageContext.getOut();
		out.println("에러가 발생하였습니다. : " + t.getMessage());
		out.println("<br><br>");
	}
	public void doFinally(){
		JspWriter out = pageContext.getOut();
		try {
			out.println("항상 마지막에 호출되는 doFinally() 메서드<br>");
		} catch (IOException e) {
			e.getMessage();
		}
	}
}