package myjsp.tag;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class ItemTag extends TagSupport {
	private static final long serialVersionUID = 1L;
	public int doStartTag() throws JspException {
		Tag parent = getParent(); // 부모 클래스를 구한다.
		if (parent == null || !(parent instanceof NumberTag)) {
			// 부모 태그가 있는지 검사한다. 
			throw new JspException("parent != NumberTag");
		}
		NumberTag numTag = (NumberTag)parent; // 실제 타입으로 형변환
		JspWriter out = pageContext.getOut();
		try {
			out.println(numTag.getCurrNumber());
		} catch (IOException e) {
			throw new JspException(e);
		}
		numTag.increaseCurrNumber();
		return EVAL_BODY_INCLUDE;
	}
	public int doEndTag() throws JspException {
		return EVAL_PAGE;
	}
}