package myjsp.tag;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class MyTag extends TagSupport {
	private static final long serialVersionUID = 1L;

	// JSP에서 시작 태그를 만나면 doStartTag() 메서드가 호출된다.
	public int doStartTag() throws JspException {
		try {
			// pageContext 객체의 getOut() 메서드를 통해
			// JspWriter 객체의 인스턴스를 생성하면 out 인스턴스를 통해
			// JSP 페이지에 출력할 수 있다.
			JspWriter out = pageContext.getOut();
			out.println("커스텀 태그 출력 메시지 : Hello JSP!");
		} catch (IOException e) {
			e.printStackTrace();
		}
		// 태그의 바디가 없는 경우 몸체 태그를 스킵한다.
		return SKIP_BODY;
	}
}