package myjsp.tag;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class RemoveHtml extends BodyTagSupport {
	private static final long serialVersionUID = 1L;
	private int length;
	private String endString;
	private String trim;
	
	public int doStartTag() throws JspException {
		return EVAL_BODY_BUFFERED;
	}
	public int doEndTag() throws JspException {
		BodyContent bodyContent = getBodyContent();
		String content = bodyContent.getString();
		
		if (trim != null && trim.equals("true")) {
			content = content.trim();
		}
		
		content = content.replaceAll("<(/)?([a-zA-Z]*)(\\s[a-zA-Z]*=[^>]*)?>", "");
		
		if (length > 0 && content.length() > length) {
			content = content.substring(0, length);
			if (endString != null) {
				content = content + endString;
			}
		}
		
		try {
			bodyContent.getEnclosingWriter().write(content);
		} catch (IOException e) {
			throw new JspException(e);
		}
		
		length = 0;
		endString = null;
		trim = null;
		return EVAL_PAGE;
	}
	
	public void setLength(int length) {
		this.length = length;
	}
	public void setEndString(String endString) {
		this.endString = endString;
	}
	public void setTrim(String trim) {
		this.trim = trim;
	}
}