package myjsp.tag;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class SimpleTag_RemoveHtml extends SimpleTagSupport {
	private static final long serialVersionUID = 1L;
	private int length;
	private String endString;
	private String trim;
	
	public void doTag() throws JspException, IOException {
		StringWriter writer = new StringWriter();
		JspFragment body = getJspBody();
		body.invoke(writer);
		String content = writer.toString();
		
		if (trim != null && trim.equals("true")) {
			content = content.trim();
		}
		
		content = content.replaceAll("<(/)?([a-zA-Z]*)(\\s[a-zA-Z]*=[^>]*)?>", "");
		
		if (length > 0 && content.length() > length) {
			content = content.substring(0, length);
			if (endString != null) {
				content = content + endString;
			}
		}
		getJspContext().getOut().print(content);
	}
	
	public void setLength(int length) {
		this.length = length;
	}
	public void setEndString(String endString) {
		this.endString = endString;
	}
	public void setTrim(String trim) {
		this.trim = trim;
	}
}