package myjsp.util;

import java.io.*;
import java.util.*;
import javax.servlet.http.*;

public class CookieUtil {
	private HashMap<String, Cookie> cookieMap = new HashMap<String, Cookie>();
	static sun.misc.BASE64Encoder encoder = new sun.misc.BASE64Encoder();
	static sun.misc.BASE64Decoder decoder = new sun.misc.BASE64Decoder();
	
	public CookieUtil(HttpServletRequest request) throws IOException {
		Cookie[] cookies = request.getCookies();
		if (cookies != null && cookies.length > 0) {
			for (int i=0; i<cookies.length; i++) {
				cookieMap.put(cookies[i].getName(), cookies[i]);
			}
		}
	}
	
	public static Cookie createCookie(String name, String value) throws IOException{
		return new Cookie(name, encoder.encode(value.getBytes()));
	}
	
	public static Cookie createCookie(String name, String value, String path, int maxAge) throws IOException {
		Cookie cookie = new Cookie(name, encoder.encode(value.getBytes()));
		cookie.setPath(path);
		cookie.setMaxAge(maxAge);
		return cookie;
	}
	
	public static Cookie createCookie(String name, String value, String domain, String path, int maxAge) throws IOException {
		Cookie cookie = new Cookie(name, encoder.encode(value.getBytes()));
		cookie.setDomain(domain);
		cookie.setPath(path);
		cookie.setMaxAge(maxAge);
		return cookie;
	}
	
	public Cookie getCookie(String name) {
		return (Cookie)cookieMap.get(name);
	}
	
	public String getValue(String name) throws IOException {
		Cookie cookie = (Cookie)cookieMap.get(name);
		if (cookie == null) {
			return null;
		} else {
			byte[] b = decoder.decodeBuffer(cookie.getValue());
			return new String(b);
		}
	}
	
	public boolean exists(String name) {
		return cookieMap.get(name) != null;
	}
}